﻿/* Popup Dashboard üzenet: insert KK! - 2020.10.22 - KRETA2-6431 */

IF (select Value from dev.EnvironmentInfo WHERE [Key] = 'Kornyezet') = N'KK'
BEGIN

    IF NOT EXISTS (SELECT 1 FROM [dbo].[T_DASHBOARDUZENET] WHERE C_EGYEDIAZONOSITO = 'POPUP_KK_GYERMEKVEDOHIVOSZAM')
    BEGIN

        INSERT INTO [dbo].[T_DASHBOARDUZENET] (C_CIM, C_EGYEDIAZONOSITO, C_ERVENYESSEGKEZDETE, C_ERVENYESSEGVEGE, C_KIEMELTIDOSZAKVEGE, C_SORREND, C_TARTALOM, C_DASHBOARDUZENETKATEGORIAID, C_ISPOPUP)
        VALUES (N'Gyermekvédő Hívószám',N'POPUP_KK_GYERMEKVEDOHIVOSZAM','2020-10-22 00:00:00','2020-11-06 23:59:59',NULL,0
        ,N'<div>
        <p><b>Tisztelt Felhasználó!</b></p>
        <p style="text-align: justify;">A <b>Szociális és Gyermekvédelmi Főigazgatóság</b> a gyermekek védelméről és a gyámügyi igazgatásról szóló 1997. évi XXXI. tv. 17. § (7) bekezdés b) pontja alapján <b>24 órás, ingyenesen hívható telefonos szolgáltatást (Gyermekvédő Hívószám)</b> működtet.</p>
        <p style="text-align: justify;"><b><u>A Gyermekvédő Hívószám elérhetősége: 06 80 212 021.</u></b> Ezen a számon <b>bárki bejelentést tehet gyermek, felnőtt veszélyeztetettségére vonatkozóan.</b> A jelzést a fogadó azonnal továbbítja a család- és gyermekjóléti szolgáltató, indokolt esetben a gyámhatóság és a rendőrség részére.</p>
        <p>A Gyermekvédő Hívószámról további információk állnak rendelkezésre a <a href="https://szgyf.gov.hu/1747-gyermekvedo-hivoszam" target="_blank"><strong><u style="color:#54a5d1;">https://szgyf.gov.hu/1747-gyermekvedo-hivoszam</u></strong></a> linken.</p>
        </div>'
        ,5,'T')

    END

    -- Gondviselők
    INSERT INTO T_DASHBOARDUZENETFELHASZNALO (
       C_MEGJELENITESEKSZAMA
      ,C_UTOLSOMEGTEKINTESIDEJE
      ,C_EGYEDIMUVELET
      ,C_DASHBOARDUZENETID
      ,C_FELHASZNALOID
      ,C_INTEZMENYID
      ,C_TANEVID
      ,TOROLT
      ,SERIAL
      ,LASTCHANGED
      ,CREATED
      ,MODIFIER
      ,CREATOR
      ,ELOZOTANEVIREKORDID
      ,C_GONDVISELOID
    ) SELECT
       1 AS C_MEGJELENITESEKSZAMA -- * int
      ,NULL AS C_UTOLSOMEGTEKINTESIDEJE -- datetime
      ,NULL AS C_EGYEDIMUVELET -- nvarchar(255)
      ,d.ID AS C_DASHBOARDUZENETID -- * int
      ,f.ID AS C_FELHASZNALOID -- * int
      ,f.C_INTEZMENYID AS C_INTEZMENYID -- * int
      ,f.C_TANEVID AS C_TANEVID -- * int
      ,'F' AS TOROLT -- * char(1)
      ,0 AS SERIAL -- * int
      ,GETDATE() AS LASTCHANGED -- * datetime
      ,GETDATE() AS CREATED -- * datetime
      ,NULL AS MODIFIER -- int
      ,NULL AS CREATOR -- int
      ,NULL AS ELOZOTANEVIREKORDID -- int
      ,g.ID AS C_GONDVISELOID -- int
    FROM T_FELHASZNALO f
      INNER JOIN T_INTEZMENY i ON i.ID = f.C_INTEZMENYID AND i.TOROLT = 'F'
      INNER JOIN T_TANEV tv ON tv.ID = f.C_TANEVID AND tv.C_INTEZMENYID = i.ID AND tv.TOROLT = 'F' AND tv.C_AKTIV = 'T'
      INNER JOIN T_GONDVISELO g ON g.C_TANULOID = f.ID AND g.TOROLT = 'F'
      INNER JOIN T_DASHBOARDUZENET d ON d.C_EGYEDIAZONOSITO = 'POPUP_KK_GYERMEKVEDOHIVOSZAM'
    WHERE
      f.TOROLT = 'F'
      AND NOT EXISTS(
        SELECT * FROM T_DASHBOARDUZENETFELHASZNALO du 
        WHERE du.C_INTEZMENYID = i.ID 
        AND du.C_TANEVID = tv.ID 
        AND du.C_DASHBOARDUZENETID = d.ID
        AND du.C_FELHASZNALOID = f.ID
        AND du.C_GONDVISELOID = g.ID
    )

    -- Tanulók
    INSERT INTO T_DASHBOARDUZENETFELHASZNALO (
       C_MEGJELENITESEKSZAMA
      ,C_UTOLSOMEGTEKINTESIDEJE
      ,C_EGYEDIMUVELET
      ,C_DASHBOARDUZENETID
      ,C_FELHASZNALOID
      ,C_INTEZMENYID
      ,C_TANEVID
      ,TOROLT
      ,SERIAL
      ,LASTCHANGED
      ,CREATED
      ,MODIFIER
      ,CREATOR
      ,ELOZOTANEVIREKORDID
      ,C_GONDVISELOID
    ) SELECT
       1 AS C_MEGJELENITESEKSZAMA -- * int
      ,NULL AS C_UTOLSOMEGTEKINTESIDEJE -- datetime
      ,NULL AS C_EGYEDIMUVELET -- nvarchar(255)
      ,d.ID AS C_DASHBOARDUZENETID -- * int
      ,t.ID AS C_FELHASZNALOID -- * int
      ,t.C_ALINTEZMENYID AS C_INTEZMENYID -- * int
      ,t.C_ALTANEVID AS C_TANEVID -- * int
      ,'F' AS TOROLT -- * char(1)
      ,0 AS SERIAL -- * int
      ,GETDATE() AS LASTCHANGED -- * datetime
      ,GETDATE() AS CREATED -- * datetime
      ,NULL AS MODIFIER -- int
      ,NULL AS CREATOR -- int
      ,NULL AS ELOZOTANEVIREKORDID -- int
      ,NULL AS C_GONDVISELOID -- int
    FROM T_TANULO t
      INNER JOIN T_INTEZMENY i ON i.ID = t.C_ALINTEZMENYID AND i.TOROLT = 'F'
      INNER JOIN T_TANEV tv ON tv.ID = t.C_ALTANEVID AND tv.C_INTEZMENYID = i.ID AND tv.TOROLT = 'F' AND tv.C_AKTIV = 'T'
      INNER JOIN T_DASHBOARDUZENET d ON d.C_EGYEDIAZONOSITO = 'POPUP_KK_GYERMEKVEDOHIVOSZAM'
    WHERE
      t.TOROLT = 'F'
      AND NOT EXISTS(
        SELECT * FROM T_DASHBOARDUZENETFELHASZNALO du 
        WHERE du.C_INTEZMENYID = i.ID 
        AND du.C_TANEVID = tv.ID 
        AND du.C_DASHBOARDUZENETID = d.ID
        AND du.C_FELHASZNALOID = t.ID
        AND du.C_GONDVISELOID is null
    )

    -- Alkalmazottak
    INSERT INTO T_DASHBOARDUZENETFELHASZNALO (
       C_MEGJELENITESEKSZAMA
      ,C_UTOLSOMEGTEKINTESIDEJE
      ,C_EGYEDIMUVELET
      ,C_DASHBOARDUZENETID
      ,C_FELHASZNALOID
      ,C_INTEZMENYID
      ,C_TANEVID
      ,TOROLT
      ,SERIAL
      ,LASTCHANGED
      ,CREATED
      ,MODIFIER
      ,CREATOR
      ,ELOZOTANEVIREKORDID
      ,C_GONDVISELOID
    ) SELECT
       1 AS C_MEGJELENITESEKSZAMA -- * int
      ,NULL AS C_UTOLSOMEGTEKINTESIDEJE -- datetime
      ,NULL AS C_EGYEDIMUVELET -- nvarchar(255)
      ,d.ID AS C_DASHBOARDUZENETID -- * int
      ,a.ID AS C_FELHASZNALOID -- * int
      ,a.C_ALINTEZMENYID AS C_INTEZMENYID -- * int
      ,a.C_ALTANEVID AS C_TANEVID -- * int
      ,'F' AS TOROLT -- * char(1)
      ,0 AS SERIAL -- * int
      ,GETDATE() AS LASTCHANGED -- * datetime
      ,GETDATE() AS CREATED -- * datetime
      ,NULL AS MODIFIER -- int
      ,NULL AS CREATOR -- int
      ,NULL AS ELOZOTANEVIREKORDID -- int
      ,NULL AS C_GONDVISELOID -- int
    FROM T_ALKALMAZOTT a
      INNER JOIN T_INTEZMENY i ON i.ID = a.C_ALINTEZMENYID AND i.TOROLT = 'F'
      INNER JOIN T_TANEV tv ON tv.ID = a.C_ALTANEVID AND tv.C_INTEZMENYID = i.ID AND tv.TOROLT = 'F' AND tv.C_AKTIV = 'T'
      INNER JOIN T_DASHBOARDUZENET d ON d.C_EGYEDIAZONOSITO = 'POPUP_KK_GYERMEKVEDOHIVOSZAM'
    WHERE
      a.TOROLT = 'F'
      AND NOT EXISTS(
        SELECT * FROM T_DASHBOARDUZENETFELHASZNALO du 
        WHERE du.C_INTEZMENYID = i.ID 
        AND du.C_TANEVID = tv.ID 
        AND du.C_DASHBOARDUZENETID = d.ID
        AND du.C_FELHASZNALOID = a.ID
        AND du.C_GONDVISELOID is null
    )

    END
ELSE
    BEGIN
    SELECT 0
    END
GO
