--NOTE: Ezt az sql-t kell lefuttatni ahhoz, hogy megjelenjen egy általunk felvett faliújság bejegyzés a tanulók és gondviselők felületén, illetve a push notification küldést.
--      Amiket át kell írni:
--      - @ervKezdete(opcionális): Az érvényesség kezdete, hogy mikortól jelenjen meg a faliújságbejegyzés. Alapból az aktuális dátum, de lehet későbbre is időzíteni.
--      - @ervVege: Az érvényesség kezdete, hogy meddig jelenjen meg a faliújságbejegyzés. 
--      - @ertesitesKuldve: Ha 'F', akkor fogunk küldeni push notification-t. Ha 'T', akkor nem fogunk küldeni push notification-t.
--      - @targy: A faliújság bejegyzés tárgya.
--      - @tartalom: Az üzenet tartalma. Ide html tag-ek nélkül kell, mivel ezt a mobil jeleníti meg. A mobil megjeleníti szépen az entereket, úgyhogy a bekezdések elválasztásához azokat használjuk.
--      - @tartalomWeb: Az üzenet tartalma. Ide html tak-ekkel kell, mivel ezt web-es felület jeleníti meg. Az alábbi tegeket használjuk formázásra:
--        - <br />: Sortörés
--        - <a style="color: blue;" href="{url}" target="_blank">{az url helyett megjelenő szöveg}</a>

IF (select Value from dev.EnvironmentInfo WHERE [Key] = 'Kornyezet') = N'KK'
BEGIN

DECLARE 
   @rendszeruzenetId int
  ,@faliujsagUzenedId int
  ,@intezmenyId int
  ,@tanevid int
  ,@targy nvarchar(max)
  ,@tartalom nvarchar(max) 
  ,@ervKezdete datetime
  ,@ervVege datetime
  ,@ertesitesKuldve char(1)
  ,@tartalomWeb nvarchar(max) 

SET @ervKezdete = '20201116 07:00'
SET @ervVege = '20210301 00:00'
SET @ertesitesKuldve = 'F'
SET @targy = 'Gyermekvédő Hívószám'

SET @tartalom = N'
Tisztelt Felhasználó!

A Szociális és Gyermekvédelmi Főigazgatóság a gyermekek védelméről és a gyámügyi igazgatásról szóló 1997. évi XXXI. tv. 17. § (7) bekezdés b) pontja alapján 24 órás, ingyenesen hívható telefonos szolgáltatást (Gyermekvédő Hívószám) működtet.

A Gyermekvédő Hívószám elérhetősége: 06 80 212 021. Ezen a számon bárki bejelentést tehet gyermek, felnőtt veszélyeztetettségére vonatkozóan. A jelzést a fogadó azonnal továbbítja a család- és gyermekjóléti szolgáltató, indokolt esetben a gyámhatóság és a rendőrség részére.

A Gyermekvédő Hívószámról további információk állnak rendelkezésre a https://szgyf.gov.hu/1747-gyermekvedo-hivoszam linken.
'

SET @tartalomWeb = N'
<p>Tisztelt Felhasználó!</p>
<p style="text-align: justify;">A Szociális és Gyermekvédelmi Főigazgatóság a gyermekek védelméről és a gyámügyi igazgatásról szóló 1997. évi XXXI. tv. 17. § (7) bekezdés b) pontja alapján 24 órás, ingyenesen hívható telefonos szolgáltatást (Gyermekvédő Hívószám) működtet.</p>
<p style="text-align: justify;">A Gyermekvédő Hívószám elérhetősége: 06 80 212 021. Ezen a számon bárki bejelentést tehet gyermek, felnőtt veszélyeztetettségére vonatkozóan. A jelzést a fogadó azonnal továbbítja a család- és gyermekjóléti szolgáltató, indokolt esetben a gyámhatóság és a rendőrség részére.</p>
<p>A Gyermekvédő Hívószámról további információk állnak rendelkezésre a <a style="color: blue;" href="https://szgyf.gov.hu/1747-gyermekvedo-hivoszam" target="_blank"><strong>https://szgyf.gov.hu/1747-gyermekvedo-hivoszam</strong></a> linken.</p>
'

DECLARE IntCursor CURSOR LOCAL FOR
SELECT i.ID , tv.ID, MIN(fh.ID)
FROM T_INTEZMENY i
  INNER JOIN T_TANEV tv On tv.C_INTEZMENYID = i.ID AND tv.TOROLT = 'F' AND tv.C_AKTIV = 'T'
  INNER JOIN T_FELHASZNALO fh ON fh.C_TANEVID = tv.ID AND fh.TOROLT = 'F' AND fh.C_NYOMTATASINEV = N'Rendszerüzenet'
WHERE i.TOROLT = 'F'
GROUP BY i.ID , tv.ID

OPEN IntCursor
FETCH NEXT FROM IntCursor INTO @intezmenyId, @tanevid, @rendszeruzenetId

WHILE @@FETCH_STATUS = 0 BEGIN

  IF NOT EXISTS (SELECT 1 FROM T_TANULOESEMENY WHERE C_TANEVID = @tanevid AND C_TARGY = @targy AND TOROLT = 'F' AND C_FELJEGYZOID =  @rendszeruzenetId) BEGIN
    INSERT INTO T_TANULOESEMENY (
       C_KEZDETE
      ,C_MEGJEGYZES
      ,C_TARTALOM
      ,C_TARTALOMWEB
      ,C_TIPUS
      ,C_TARGY
      ,C_FALIUJSAGMEGJELENES
      ,C_MINDENKINEK
      ,C_VEGE
      ,C_ROGZITESDATUMA
      ,C_ISERTESITESELKULDVE
      ,C_FELJEGYZOID
      ,C_TANTARGYID
      ,C_TANITASIORAID
      ,C_INTEZMENYID
      ,C_TANEVID
      ,TOROLT
      ,SERIAL
      ,LASTCHANGED
      ,CREATED
      ,MODIFIER
      ,CREATOR
      ,ELOZOTANEVIREKORDID
    ) SELECT
        @ervKezdete AS C_KEZDETE -- datetime
      ,'Rendszerüzenet' AS C_MEGJEGYZES -- nvarchar(255)
      ,@tartalom AS C_TARTALOM -- * nvarchar(max)
      ,@tartalomWeb AS C_TARTALOMWEB -- nvarchar(max)
      ,5482 AS C_TIPUS -- * int
      ,@targy AS C_TARGY -- * nvarchar(255)
      ,'T' AS C_FALIUJSAGMEGJELENES -- char(1)
      ,'T' AS C_MINDENKINEK -- char(1)
      ,@ervVege AS C_VEGE -- datetime
      ,GETDATE() AS C_ROGZITESDATUMA -- * datetime
      ,@ertesitesKuldve AS C_ISERTESITESELKULDVE -- * char(1)
      ,@RendszeruzenetId AS C_FELJEGYZOID -- * int
      ,NULL AS C_TANTARGYID -- int
      ,NULL AS C_TANITASIORAID -- int
      ,@intezmenyId AS C_INTEZMENYID -- * int
      ,@tanevid AS C_TANEVID -- * int
      ,'F' AS TOROLT -- * char(1)
      ,0 AS SERIAL -- * int
      ,GETDATE() AS LASTCHANGED -- * datetime
      ,GETDATE() AS CREATED -- * datetime
      ,NULL AS MODIFIER -- int
      ,NULL AS CREATOR -- int
      ,NULL AS ELOZOTANEVIREKORDID -- int

    SET @faliujsagUzenedId = SCOPE_IDENTITY()

    INSERT INTO T_OSZTALYCSOPORT_TANULOESEMENY (C_OSZTALYCSOPORTID, C_TANULOESEMENYID)
    SELECT ID, @faliujsagUzenedId
    FROM T_OSZTALY WHERE TOROLT = 'F' AND C_ALTANEVID = @tanevid

    INSERT INTO T_TANULO_TANULOESEMENY (C_TANULOID, C_TANULOESEMENYID)
    SELECT ID, @faliujsagUzenedId
    FROM T_TANULO WHERE TOROLT = 'F' AND C_ALTANEVID = @tanevid
    
  END
  --OPEN IntCursor
  FETCH NEXT FROM IntCursor INTO @intezmenyId, @tanevid, @rendszeruzenetId

END

END -- KK környezet
GO
