﻿--      Amiket át kell írni:
--      - @ervKezdete(opcionális): Az érvényesség kezdete, hogy mikortól jelenjen meg a faliújságbejegyzés. Alapból az aktuális dátum, de lehet későbbre is időzíteni.
--      - @ervVege: Az érvényesség kezdete, hogy meddig jelenjen meg a faliújságbejegyzés. 
--      - @ertesitesKuldve: Ha 'F', akkor fogunk küldeni push notification-t. Ha 'T', akkor nem fogunk küldeni push notification-t.
--      - @targy: A faliújság bejegyzés tárgya.
--      - @tartalom: Az üzenet tartalma. Ide html tag-ek nélkül kell, mivel ezt a mobil jeleníti meg. A mobil megjeleníti szépen az entereket, úgyhogy a bekezdések elválasztásához azokat használjuk.
--      - @tartalomWeb: Az üzenet tartalma. Ide html tak-ekkel kell, mivel ezt web-es felület jeleníti meg. Az alábbi tegeket használjuk formázásra:
--        - <br />: Sortörés
--        - <a style="color: blue;" href="{url}" target="_blank">{az url helyett megjelenő szöveg}</a>

/* 2021.01.27 - KRETA2-7363 */

/* FaliUjsag */
DECLARE 
   @rendszeruzenetId int
  ,@faliujsagUzenedId int
  ,@intezmenyId int
  ,@tanevid int
  ,@targy nvarchar(max)
  ,@tartalom nvarchar(max) 
  ,@ervKezdete datetime
  ,@ervVege datetime
  ,@ertesitesKuldve char(1)
  ,@tartalomWeb nvarchar(max) 

SET @ervKezdete = '20210127 08:00'
SET @ervVege = '20210307 23:59:59'
SET @ertesitesKuldve = 'F'
SET @targy = 'Indul a ZsetON - Hangolódj a pénzügyekre!'

SET @tartalom = N'
Indul a ZsetON - Hangolódj a pénzügyekre!

2021. március 7-ig lehet kitölteni a ZsetOn - Hangolódj a pénzügyekre! országos verseny első fordulójának tesztsorát.

A versenyt a Pénzügyminisztérium szervezi, a Diákhitel Központ Zrt., a Pénziránytű Alapítvány, a Magyar Biztosítók Szövetsége (MABISZ) és a Magyar Államkincstár támogatásával.

A 2020. december 21-én indult játékban 14-19 éves középiskolások vehetnek részt, 200 különböző nehézségi szintű kérdésből egy program véletlenszerűen választ ki 16 kérdést. A teszt többször is kitölthető, így könnyen rutinra tehetnek szert a fiatalok a pénzügyek területén. Egyetlen e-mailcímről csak egyszer lehet regisztrálni, ÉRDEMES EZÉRT REGISZTRÁCIÓ NÉLKÜL ELŐZETESEN GYAKOROLNI, s csak a már biztos tudás birtokában kitölteni a végső kvízt.

A középiskolások közül az első 150 legjobb eredményt elérő jut tovább a középdöntőbe, amely a tervek szerint már személyes részvétellel zajlik 2021. március 26-án a Pénzügyminisztériumban. A középdöntő legjobbjai pedig még aznap egy látványos döntő keretében mérhetik össze tudásukat. A verseny első 3 helyezettje értékes elektronikai eszközöket, laptopot, tabletet és mobiltelefont nyer.

Jó versenyzést kívánunk!'

SET @tartalomWeb = N'
<p><u><a style="color: blue;" href="https://tudasbazis.ekreta.hu/download/attachments/2424949/Versenyfelh%C3%ADv%C3%A1s.pdf?api=v2" target="_blank"><strong><strong>Indul a ZsetON - Hangolódj a pénzügyekre!</strong></strong></a></u></p>
<p><strong>2021. március 7-ig lehet kitölteni a ZsetOn - Hangolódj a pénzügyekre! országos verseny első fordulójának tesztsorát.</strong></p>
<p style="text-align: justify;">A versenyt a Pénzügyminisztérium szervezi, a Diákhitel Központ Zrt., a Pénziránytű Alapítvány, a Magyar Biztosítók Szövetsége (MABISZ) és a Magyar Államkincstár támogatásával.</p>
<p style="text-align: justify;">A 2020. december 21-én indult játékban 14-19 éves középiskolások vehetnek részt, 200 különböző nehézségi szintű kérdésből egy program véletlenszerűen választ ki 16 kérdést. A teszt többször is kitölthető, így könnyen rutinra tehetnek szert a fiatalok a pénzügyek területén. Egyetlen e-mailcímről csak egyszer lehet regisztrálni, ÉRDEMES EZÉRT REGISZTRÁCIÓ NÉLKÜL ELŐZETESEN GYAKOROLNI, s csak a már biztos tudás birtokában kitölteni a végső kvízt.</p>
<p style="text-align: justify;">A középiskolások közül <strong>az első 150 legjobb eredményt elérő jut tovább a középdöntőbe</strong>, amely a tervek szerint már személyes részvétellel zajlik 2021. március 26-án a Pénzügyminisztériumban. A középdöntő legjobbjai pedig még aznap egy látványos döntő keretében mérhetik össze tudásukat. A verseny első 3 helyezettje értékes elektronikai eszközöket, laptopot, tabletet és mobiltelefont nyer.</p>
<p>Jó versenyzést kívánunk!</p>
'

DECLARE IntCursor CURSOR LOCAL FOR
SELECT i.ID , tv.ID, MIN(fh.ID)
FROM T_INTEZMENY i
  INNER JOIN T_TANEV tv On tv.C_INTEZMENYID = i.ID AND tv.TOROLT = 'F' AND tv.C_AKTIV = 'T'
  INNER JOIN T_FELHASZNALO fh ON fh.C_TANEVID = tv.ID AND fh.TOROLT = 'F' AND fh.C_NYOMTATASINEV = N'Rendszerüzenet'
WHERE i.TOROLT = 'F'
GROUP BY i.ID , tv.ID

OPEN IntCursor
FETCH NEXT FROM IntCursor INTO @intezmenyId, @tanevid, @rendszeruzenetId

WHILE @@FETCH_STATUS = 0 BEGIN

  IF NOT EXISTS (SELECT 1 FROM T_TANULOESEMENY WHERE C_TANEVID = @tanevid AND C_TARGY = @targy AND TOROLT = 'F' AND C_FELJEGYZOID =  @rendszeruzenetId) BEGIN
    INSERT INTO T_TANULOESEMENY (
       C_KEZDETE
      ,C_MEGJEGYZES
      ,C_TARTALOM
      ,C_TARTALOMWEB
      ,C_TIPUS
      ,C_TARGY
      ,C_FALIUJSAGMEGJELENES
      ,C_MINDENKINEK
      ,C_VEGE
      ,C_ROGZITESDATUMA
      ,C_ISERTESITESELKULDVE
      ,C_FELJEGYZOID
      ,C_TANTARGYID
      ,C_TANITASIORAID
      ,C_INTEZMENYID
      ,C_TANEVID
      ,TOROLT
      ,SERIAL
      ,LASTCHANGED
      ,CREATED
      ,MODIFIER
      ,CREATOR
      ,ELOZOTANEVIREKORDID
    ) SELECT
        @ervKezdete AS C_KEZDETE -- datetime
      ,'Rendszerüzenet' AS C_MEGJEGYZES -- nvarchar(255)
      ,@tartalom AS C_TARTALOM -- * nvarchar(max)
      ,@tartalomWeb AS C_TARTALOMWEB -- nvarchar(max)
      ,5482 AS C_TIPUS -- * int
      ,@targy AS C_TARGY -- * nvarchar(255)
      ,'T' AS C_FALIUJSAGMEGJELENES -- char(1)
      ,'T' AS C_MINDENKINEK -- char(1)
      ,@ervVege AS C_VEGE -- datetime
      ,GETDATE() AS C_ROGZITESDATUMA -- * datetime
      ,@ertesitesKuldve AS C_ISERTESITESELKULDVE -- * char(1)
      ,@RendszeruzenetId AS C_FELJEGYZOID -- * int
      ,NULL AS C_TANTARGYID -- int
      ,NULL AS C_TANITASIORAID -- int
      ,@intezmenyId AS C_INTEZMENYID -- * int
      ,@tanevid AS C_TANEVID -- * int
      ,'F' AS TOROLT -- * char(1)
      ,0 AS SERIAL -- * int
      ,GETDATE() AS LASTCHANGED -- * datetime
      ,GETDATE() AS CREATED -- * datetime
      ,NULL AS MODIFIER -- int
      ,NULL AS CREATOR -- int
      ,NULL AS ELOZOTANEVIREKORDID -- int

    SET @faliujsagUzenedId = SCOPE_IDENTITY()

    INSERT INTO T_OSZTALYCSOPORT_TANULOESEMENY (C_OSZTALYCSOPORTID, C_TANULOESEMENYID)
    SELECT o.ID, @faliujsagUzenedId
    FROM T_OSZTALY o
      INNER JOIN T_OSZTALYCSOPORT ocs on ocs.ID = o.ID AND ocs.TOROLT = 'F'
    WHERE o.TOROLT = 'F' AND C_ALTANEVID = @tanevid
      AND ocs.C_EVFOLYAMTIPUSA IN (1311,1312,1313,1314,1332,1333,1336,3018,3019,7111,7111,7112,7112,7113,7114
      ,7115,7115,7116,7116,7117,7118,7119,7119,7120,7121,7122,7123,7123,7124,7124,7125,7126,7127,7127,7128,7862
      ,7863,7864,7865,7868,7869,7870,7871,7872,7873,7874,7875,7876,7877,7878,7901,7902,7905,7906,7907,7908,7909
      ,8396,8397,8398,8399
      )

    INSERT INTO T_TANULO_TANULOESEMENY (C_TANULOID, C_TANULOESEMENYID)
    SELECT DISTINCT t.ID, @faliujsagUzenedId
    FROM T_TANULO t
      INNER JOIN T_TANULOCSOPORT tcs ON tcs.C_TANULOID = t.ID AND tcs.TOROLT = 'F' AND tcs.C_BELEPESDATUM < GETDATE() AND (tcs.C_KILEPESDATUM > GETDATE() OR tcs.C_KILEPESDATUM IS NULL) 
      INNER JOIN T_OSZTALYCSOPORT ocs ON ocs.ID = tcs.C_OSZTALYCSOPORTID AND ocs.TOROLT = 'F'
      INNER JOIN T_OSZTALY o ON o.ID = ocs.ID AND o.TOROLT = 'F'
    WHERE t.TOROLT = 'F' AND t.C_ALTANEVID = @tanevid
      AND ocs.C_EVFOLYAMTIPUSA IN (1311,1312,1313,1314,1332,1333,1336,3018,3019,7111,7111,7112,7112,7113,7114
      ,7115,7115,7116,7116,7117,7118,7119,7119,7120,7121,7122,7123,7123,7124,7124,7125,7126,7127,7127,7128,7862
      ,7863,7864,7865,7868,7869,7870,7871,7872,7873,7874,7875,7876,7877,7878,7901,7902,7905,7906,7907,7908,7909
      ,8396,8397,8398,8399
      )
    
  END
  --OPEN IntCursor
  FETCH NEXT FROM IntCursor INTO @intezmenyId, @tanevid, @rendszeruzenetId

END -- while
GO
/* END FaliUjsag */

/* Dashboard */
/* END Dashboard */

/* Popup */
/* END Popup */